<?php

/*!! Structure.Actions.AdminEditTable:
  .      .

  FIELDS: ##:::: ...##
## :-  :  : :  ##

:

  * tname - table name
  * key - key in the table (one field only!)
  * fields - show fields

@link Examples.DB:
 1:    ,   :
%%(code)
{{adminviewtable tname="zayavki" header=":::::" fields="family:name:otchestvo:klass:pansion:adddata" key="id"}}

{{adminedittable tname="zayavki" fields=":family:text: :::name:text: :::otchestvo:text: :: :klass:text: ::  ( '+',  ,       ):pansion:text: :: ,      :adddata:textarea: " key="id" btnadd=" "}}
%%

 2:   **adminbasicontology**:

%%(phpplus)
if($this->IsAdmin()) {
   // security init
   $this->secAdminedittable = true;
   $this->secAdminviewtable = true;
   // init adminviewtable
   $tname='basicontology';
   $header='ID:::';
   $fields='id:owner:name:title';
   $maxsymbols = 120;
   $atype = "compact";
   include('actions/adminviewtable.php');

   echo "<br />";
   // init adminedittable
   $fields=':owner:text:SiteAdmin:::name:text: :::title:text: ';
   include('actions/adminedittable.php');
   //security finalization
   $this->secAdminedittable = false;
   $this->secAdminviewtable = false;
}
%%

 3 -     (    notparse):
%%(phpplus)
if($this->IsAdmin()) {
   // security init
   $this->secAdminedittable = true;
   $this->secAdminviewtable = true;
   // init adminviewtable
   $tname='wiki_proverb_model';
   $header='id:ID ::: ';
   $fields='id:modelId:username:writetime:latest';
   $maxsymbols = 120;
   $atype = "compact";
   include('actions/adminviewtable.php');

   echo "<br />";
   // init adminedittable
   $notparse = '1';
   $fieldar = array ( array ('ID ','modelId','int', ''),
                      array ('','username','tselect table="users" field="name" key="name"', ''),
                      array ('','writetime','datetime', ''),
                      array (' ','latest','checkbox', '0'),
              );

   include('actions/adminedittable.php');
   //security finalization
   $this->secAdminedittable = false;
   $this->secAdminviewtable = false;
}
%%
@link Structure.Actions, Function.DB, User.Developer:
!!  .!!
*/

//     
$rsvCntid = $this->cntReserve(1);
$rsvId = $this->cntGet($rsvCntid);

if($this->secAdminedittable) {
// case complex JS
$_GET["editid"] = $this->tryUtfDecode($_GET["editid"]);

if($key=="") $key="id";
if($max==0) $max=10;

if(isset($firstcolwidth)) $firstcolwidth = (int)$firstcolwidth; else $firstcolwidth = 12;

//if($onlyadd=="1") $onlyadd=true; else $onlyadd=false;


if ($_POST["preview"]) {
   echo "<i>Unitable ".$this->GRV("DisableOnPageview")."</i><br />";
} else {

  //    -  
  if($notparse!='1') {
     $fieldar1 = explode("::",$fields);
     $fieldar = array();
     foreach($fieldar1 as $field) {
       $fieldar[] = explode(":",$field);
     }
  }

  if($_POST["abstract_add".$rsvId]=='1') {
     // antispam feature
     $accept = $this->GetUser();
     if(!$accept) {
         $accept = $this->vfrmProcess("kcaptcha", "ccha"); //(int)$_REQUEST["aspam"] + 5 == (int)$_REQUEST["aspammsg"];
     }
     if($accept) {
                $sqlst = "";
                foreach($fieldar as $fldinfo) {
                   $curvar = "";
                   $curvar = $this->vfrmProcess($fldinfo[2],$fldinfo[1]);
                   $sqlst .= ", ".$fldinfo[1]."='".quote($curvar)."'";
               }
               $sqlst = substr($sqlst,1);

               if($_POST[$key.'nafig']=="") {
                    $this->Query('INSERT INTO '.$this->config["table_prefix"].$tname." SET ".$sqlst);
                    $resid = $this->dbGetLatestId();
                    if($this->uniEditTableAddSignal) {
                       $this->srvRunAll($this->uniEditTableAddSignal, array("id" => $resid));
                       //$tmpAddMsg .= " (signal run)";
                    }
                    $this->SetMessage($msgadd?$msgadd:($this->GRV("RecordAdded")." $tname"));
                    if($this->uniEditTableAddRedirect) {
                       $href = $this->uniEditTableAddRedirect;
                    } else {
                       $href = $this->href();
                    }
               } else {
                  if(!$onlyadd) {
                    $this->Query('UPDATE '.$this->config["table_prefix"].$tname." SET ".$sqlst." WHERE $key='".quote($_POST[$key.'nafig'])."'");               if($this->uniEditTableEditSignal) {
                       $this->srvRunAll($this->uniEditTableEditSignal, array("id" => $_POST[$key.'nafig']));
                       //$tmpAddMsg .= " (signal run)";
                    }
                    $this->SetMessage($msgedit?$msgedit:($this->GRV("RecordChanged")." ".$tname));
                    if($this->uniEditTableEditRedirect) {
                       $href = $this->uniEditTableEditRedirect;
                    } else {
                       $href = $this->href();
                    }
                  }
               }
               if($href == "") $href = $this->href();
               $this->redirect($href);
     } else {
           $this->SetMessage($this->GRV("AntiSpamNumberIncorrect"));
           $this->Arefresh();
     }
  } else {
  if (($_GET["deleteid"]!='') && !$onlyadd) {
      if($this->uniEditTableDelSignal) {
         $this->srvRunAll($this->uniEditTableDelSignal, array("id" => (int)$_GET["deleteid"]));

      }
      $this->Query('DELETE FROM '.$this->config["table_prefix"].$tname." WHERE $key='".quote($_GET["deleteid"])."'");
      $this->SetMessage("    $tname");
      $this->redirect($this->href());
  } else {
      if(!$onlyadd && !$hideheader) echo "<div align=center><i>".$this->GRV("TableEditing")." $tname</i></div><br>\n";
      ?>
<form name="editform" method="post">
<input type="hidden" name="abstract_add<?php echo $rsvId; ?>" value="1" />
      <?php
      if($token) { ?>
<input type="hidden" name="abstract_addtoken" value="<?php echo htmlXspecialchars($token); ?>" />
      <?php
      }
      echo '<table style="width:100%; border:0px">';

      $isedit = false;
      if (($_GET["editid"]!='') && !$onlyadd) {
           $isedit=true;
           $curab = $this->LoadSingle('SELECT * FROM `'.$this->config["table_prefix"].$tname."` WHERE $key='".quote($_GET["editid"])."'");
      }
      ?>

      <?php
        // antispam feature
              if(!$this->GetUser()) {
                  $antiSpamId = rand(1,100);
              } else {
                  $antiSpamId = 0;
              }


        foreach($fieldar as $fldinfo) {
            echo "<tr><td align='right'>".$fldinfo[0]."</td><td></td><td align='left'>";
            echo $this->vfrmField($fldinfo[1],$fldinfo[2],$isedit?$curab[$fldinfo[1]]:trim($fldinfo[3]));
            echo "</td></tr>\n";
        }
        if($antiSpamId!=0) {
            /* echo '<input type="hidden" name="aspam" value="'.$antiSpamId.'" />';
            echo ',   '.$antiSpamId.'+5: <input type="text" name="aspammsg" />        .<br />'; */
            echo "<tr><td align='right'>".$this->GRV("PleaseEnterAntiSpamNumber")."</td><td></td><td align='left'>";
            echo $this->vfrmField('ccha','kcaptcha','');
            echo "</td></tr>\n";
         }
        if($isedit) echo '<input type="hidden" name="'.$key.'nafig" value="'.$_GET["editid"].'" />';
      ?>
      <tr><td width="<?php echo $firstcolwidth; ?>%"></td><td width="1%"></td><td>
      <input type="submit" class="btn" value="<?php if($isedit) echo ($btnedit?$btnedit:$this->GRV("EditStoreButton")); else echo ($btnadd?$btnadd:""); ?>" /></td></tr>
      <?php

      echo "</table>";
      echo $this->FormClose();
  }
  }

}
}
?>
