<?php
// $Id: wakka.php 495 2005-03-27 12:49:11Z kukutz $
// $Date: 2005-03-27 16:49:11 +0400 (Sun, 27 Mar 2005) $                        $Revision: 1.139 $

// app start
error_reporting (E_ALL ^ E_NOTICE ^ E_DEPRECATED);

if (ini_get("zlib.output_compression"))
  ob_start();
else
  ob_start("ob_gzhandler");

define('XML_HTMLSAX3', dirname(__FILE__)."/lib/HTMLSax3/");

// stupid version check
if (!isset($_REQUEST)) die('$_REQUEST[] not found. WackoWiki requires PHP 4.1.0 or higher!');

// workaround for the amazingly annoying magic quotes.
function magicQuotesSuck(&$a)
{
  if (is_array($a))
  {
    foreach ($a as $k => $v)
    {
      if (is_array($v))
        magicQuotesSuck($a[$k]);
      else
        $a[$k] = stripslashes($v);
    }
  }
}
// disable magic quotes on old versions
if(version_compare(PHP_VERSION, '7.0.0', '<')){
	set_magic_quotes_runtime(0);
	if (get_magic_quotes_gpc())
	{
	  magicQuotesSuck($_POST);
	  magicQuotesSuck($_GET);
	  magicQuotesSuck($_COOKIE);
	  magicQuotesSuck($_SERVER);
	  magicQuotesSuck($_REQUEST);
	}
}

if (strstr($_SERVER["SERVER_SOFTWARE"], "IIS")) $_SERVER["REQUEST_URI"] = $_SERVER["PATH_INFO"];

include("crosssite.php");
// default configuration values
include("dist/default_config.php");
// load config
if (!$configfile = GetEnv("WAKKA_CONFIG")) $configfile = $crossSiteConfigFile;
if (@file_exists($configfile)) include($configfile);
$wakkaConfigLocation = $configfile;
$wakkaConfig = array_merge($wakkaDefaultConfig, (array)$wakkaConfig);

// check for locking
if (@file_exists("locked")) {
  // read password from lockfile
  $lines = file("locked");
  $lockpw = trim($lines[0]);

  // is authentification given?
  if (isset($_SERVER["PHP_AUTH_USER"])) {
    if (!(($_SERVER["PHP_AUTH_USER"] == "admin") && ($_SERVER["PHP_AUTH_PW"] == $lockpw))) {
      $ask = 1;
    }
  } else {
    $ask = 1;
  }

  if ($ask) {
    header("WWW-Authenticate: Basic realm=\"".$wakkaConfig["wakka_name"]." Install/Upgrade Interface\"");
    header("HTTP/1.0 401 Unauthorized");
    print("This site is currently being upgraded. Please try again later.");
    exit;
    }
}

// compare versions, start installer if necessary
if ($wakkaConfig["wacko_version"] != WACKO_VERSION)
{
  if (!$_REQUEST["installAction"] && !strstr($_SERVER["SERVER_SOFTWARE"], "IIS"))
  {
   $req = $_SERVER["REQUEST_URI"];
   if ($req{strlen($req)-1}!="/" && strstr($req, ".php")!=".php") {
    header("Location: http://".$_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"]."/");
    exit;
   }
  }
  // start installer
  if (!$installAction = trim($_REQUEST["installAction"])) $installAction = "lang";
  include("setup/header.php");
  if (@file_exists("setup/".$installAction.".php")) include("setup/".$installAction.".php"); else print("<em>Invalid action</em>");
  include("setup/footer.php");
  exit;
}

// set root_url & theme_url
if (!isset($wakkaConfig["root_url"])) $wakkaConfig["root_url"]=preg_replace("#/[^/]*$#","/",$wakkaConfig["base_url"]);
$wakkaConfig["theme_url"]=$wakkaConfig["root_url"]."themes/".$wakkaConfig["theme"]."/";

//user-table
if (!isset($wakkaConfig["user_table"]) && !$wakkaConfig["user_table"]) $wakkaConfig["user_table"] = $wakkaConfig["table_prefix"]."users";

// fetch wakka location
if (isset($_SERVER["PATH_INFO"]) && function_exists("virtual")) $request = $_SERVER["PATH_INFO"];
else $request = @$_REQUEST["wakka"];

// fix win32 apache 1 bug
if (stristr($_SERVER["SERVER_SOFTWARE"], "Apache/1") && stristr($_SERVER["SERVER_SOFTWARE"], "Win32") && $wakkaConfig["rewrite_mode"])
{
 $dir = str_replace("http://".$_SERVER["SERVER_NAME"].($_SERVER["SERVER_PORT"] != 80 ? ":".$_SERVER["SERVER_PORT"] : ""),"",$wakkaConfig["base_url"]);
 $request = preg_replace("+^".preg_quote(rtrim($dir,"/"))."+i","",$_SERVER["REDIRECT_URL"]);//$request);
}

// remove leading slash
$request = preg_replace("/^\//", "", $request);
$method = '';

// try find userMagicCode

$userMagicCode = "";
$p = strpos($request, '_');
if($p === 0) {
   $req_t = explode('/', $request, 2);
   $request = $req_t[1];
   $userMagicCode = substr($req_t[0],1);
}

// find handler

$p = strpos($request, "/");
if ($p === false) {
  $p = strlen($request)+1;
}
$handler = substr($request, 0, $p);
if (!preg_match('/^[A-Za-z0-9]+$/',$handler)) {
  $handler='page';
} else {
if (!@file_exists($wakkaConfig["handler_path"]."/".$handler)) {
  $handler = 'page';
} else {
  $request = substr($request, $p-strlen($request)+1);
}}

//$handler = 'page';


// split into page/method
$p = strrpos($request, "/");
if ($p === false) {
 $page = $request;
} else {
 $page = substr($request, 0, $p);
 $m1 = $method = strtolower(substr($request, $p-strlen($request)+1));
 if (!@file_exists(($wakkaConfig["common_path"]!=""?$wakkaConfig["common_path"].'/':'').$wakkaConfig["handler_path"]."/".$handler."/".$method.".php"))
 {
  $page = $request;
  $method = "";
 } else if (preg_match( '/^(.*?)\/('.$wakkaConfig["standart_handlers"].')($|\/(.*)$)/i', $page, $match ))
 {//translit case
  $page = $match[1];
  $method = $match[2];
 }
}

// load dbal
if (!isset( $wakkaConfig["db_layer"] )) $wakkaConfig["db_layer"] = "mysql";
if($wakkaConfig["db_layer"] == "mysql") {
	if(!function_exists('mysql_query')) {
	//if(true) {
		// trying to switch to mysqli processor
		$wakkaConfig["db_layer"] = "mysqli";
	}
}
$dbfile = ($wakkaConfig["common_path"]!=""?$wakkaConfig["common_path"].'/':'')."db/".$wakkaConfig["db_layer"].".php";
if (@file_exists($dbfile)) include($dbfile);
else die("Error loading DBAL.");

// control check

$indFileContent = file_get_contents('index.php');
$indFileContent = str_replace("\n", '', str_replace("\r", '', $indFileContent));
$crcIndFileContent = crc32($indFileContent);
if(($crcIndFileContent != 1865897377) && ($crcIndFileContent != -1117074507)) {
   echo '<div align="center"><b>Sorry, the site is temporary unavailable due to the security reasons.<br /><br />FOR ADMINISTRATION: Please, check the INDEX.PHP consistency</b></div>';
   //$flag = file_get_contents('sites/'.$crossSiteName.'/)
   //echo crc32($indFileContent);
   include('lib/antivirus/main.php');

   die();

}


require("xcbase.php");
require("classes/qsminikernel.php");

if($wakkaConfig["subdomain_processing"] == "1") {
  include('sites/'.$crossSiteName.'/subdomains/sub'.($crossSiteSubdomain==""?'':'.'.$crossSiteSubdomain).'.php');
} else {
  include('handlers/'.$handler.'.init.php');
}

?>